<?php
namespace Teknisa\Model\Gestaopessoas\Repositories;


class GpeVinculoh extends \Doctrine\ORM\EntityRepository {
    

    public function retornaUltimoHistoricoCompetencia($nrorg, $nrvinculom, $competencia) {
	$params = array('dtmescompetenc'=>$competencia, 'nrorg'=>$nrorg, 'nrvinculom' =>$nrvinculom);
    $gpevinculoh =  'Teknisa\Model\Gestaopessoas\Entities\GpeVinculoh';
$sql = <<<SQL
SELECT s FROM $gpevinculoh s
WHERE s.nrorg = :nrorg 
AND s.nrvinculom = :nrvinculom
AND s.dtmescompetenc = (SELECT MAX(gvhs.dtmescompetenc)
                          FROM $gpevinculoh gvhs
                         WHERE gvhs.nrorg = s.nrorg
                           AND gvhs.nrvinculom = s.nrvinculom
                           AND gvhs.dtmescompetenc <= :dtmescompetenc)
SQL;

        $result = $this->getEntityManager()->createQuery($sql)->execute($params);
      
        if(!empty($result))
        	return $result[0];
        else 
        	return $result;
    }
    
    public function retornaHistoricoCompetencia($nrorg, $nrvinculom, $competencia) {
    	$params = array('dtmescompetenc'=>$competencia->format('d/m/Y'), 'nrorg'=>$nrorg, 'nrvinculom' =>$nrvinculom);
        $gpevinculoh =  'Teknisa\Model\Gestaopessoas\Entities\GpeVinculoh';
$sql = <<<SQL
SELECT s FROM $gpevinculoh s
WHERE s.nrorg = :nrorg 
AND s.nrvinculom = :nrvinculom
AND s.dtmescompetenc = :dtmescompetenc
SQL;
        
        $result = $this->getEntityManager()->createQuery($sql)->execute($params);

        if(!empty($result))
        	return $result[0];
        else 
        	return $result;
    }
    
    public function retornaVinculoPorMatriculaESocial($nrorg, $nrvinculom, $matricula, $dtmescompetenc, $estrutura){
    	
        $gpevinculoh =  'Teknisa\Model\Gestaopessoas\Entities\GpeVinculoh';
$sql = <<<SQL
SELECT s
  FROM $gpevinculoh s
 WHERE s.nrorg = :p_nrorg 
   AND (s.nrvinculom <> :p_nrvinculom OR :p_nrvinculom IS NULL) 
   AND (s.nrestrutlegal = :p_nrestruturam OR :p_nrestruturam IS NULL)
   AND s.cdmatriculaesocial = :p_cdmatriculaesocial
   AND s.dtmescompetenc = (SELECT MAX(vh.dtmescompetenc)
                             FROM $gpevinculoh vh
                            WHERE vh.nrorg = s.nrorg
                              AND vh.nrvinculom = s.nrvinculom
                              AND vh.nrestrutlegal = s.nrestrutlegal
                              AND vh.dtmescompetenc <= :p_dtmescompetenc)
SQL;
        $params = array('p_dtmescompetenc'     => $dtmescompetenc->format('d/m/Y'),
                        'p_nrorg'              => $nrorg, 
                        'p_nrvinculom'         => $nrvinculom,
                        'p_nrestruturam'       => $estrutura,
                        'p_cdmatriculaesocial' => $matricula);
        $result = $this->getEntityManager()->createQuery($sql)->execute($params);  

        if(!empty($result))
        	return $result[0];
        else 
        	return $result;
    }

}