<?php
namespace Zeedhi\DevOps\Model\Configurationmanager\Repositories;


use Zeedhi\DevOps\Model\Configurationmanager;

class Package extends \Doctrine\ORM\EntityRepository {
    /**
     * @param $productVersionId
     * @param $organizationId
     * @return array
     */
    public function getPackageByProductVersion($productVersionId,$organizationId) {
        $productVersionFilter = $productVersionId ? " WHERE PV.ID = $productVersionId" : "";
        $query = <<<SQL
			SELECT PP.ID, PP.NAME
              FROM PRODUCT_VERSION_PACKAGES PP
             INNER JOIN PRODUCT_VERSION PV ON PV.ID = PP.PRODUCT_VERSION_ID
             $productVersionFilter
             AND PP.ORGANIZATION_ID = $organizationId
SQL;
        return $this->getEntityManager()->getConnection()->fetchAll($query);
    }

    /**
     * @param $productId
     * @param $organizationId
     * @return array
     */
    public function findReleasePackagesByProduct($productId,$organizationId) {
        $query = <<<SQL
			SELECT ID
              FROM PACKAGE
             WHERE ORGANIZATION_ID = :ORGANIZATION
               AND RELEASE_ID IN (SELECT ID
                                    FROM RELEASE
                                   WHERE PRODUCT_ID = :PRODUCT_ID
                                     AND IS_ACTIVE = :RELEASE_POSITIVE_IS_ACTIVE
                                     AND STATUS <> :RELEASE_HOMOLOGATED_STATUS)
             GROUP BY ID
SQL;
        $params = array(
            'PRODUCT_ID' => $productId ,
            'RELEASE_HOMOLOGATED_STATUS' => Configurationmanager\Entities\Release::HOMOLOGATED_STATUS,
            'RELEASE_POSITIVE_IS_ACTIVE' => Configurationmanager\Entities\Release::POSITIVE_IS_ACTIVE,
            'ORGANIZATION' => $organizationId,
        );

        return $this->getEntityManager()->getConnection()->fetchAll($query, $params);
    }

    /**
     * @param $productId
     * @param $filterQuery
     * @return array
     */
    public function findProductPackages($productId, $filterQuery){
        $query = <<<SQL
            SELECT *
              FROM (SELECT ID, PATH_TO_DEPLOY AS PRODUCT_PATH
                      FROM PACKAGE
                     WHERE PRODUCT_ID = :PRODUCT)
             WHERE 1 = 1
             $filterQuery
SQL;
        $params = array(
            'PRODUCT' => $productId
        );

        return $this->getEntityManager()->getConnection()->fetchAll($query, $params);
    }
}