IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
           WHERE O.NAME = 'VALOR_PEDIDO_LIQUIDO' AND
                 TYPE = 'FN' 		       AND
	              U.UID = O.UID            AND
	              U.NAME = USER)
DROP FUNCTION VALOR_PEDIDO_LIQUIDO
GO
CREATE FUNCTION VALOR_PEDIDO_LIQUIDO(
   @P_CDFILIAL     VARCHAR(4),
   @P_NRPEDIDO    VARCHAR(10)) RETURNS NUMERIC(10,5)
AS
BEGIN
   DECLARE @V_VRPEDIDO DOUBLE PRECISION;
   DECLARE @V_VRITEM DOUBLE PRECISION;

   SET @V_VRPEDIDO = 0;

   SELECT @V_VRITEM = SUM((I.QTITEMPED * I.VRPREUNITPED) - (ISNULL(I.VRDESITPED,0)))
     FROM ITEMPEDIDO I
    WHERE I.CDFILIAL = @P_CDFILIAL
      AND I.NRPEDIDO = @P_NRPEDIDO;


   SET @V_VRPEDIDO = @V_VRITEM;

   RETURN(@V_VRPEDIDO);
END
GO

-- VERSAO --
EXEC ATUVEROBJ 'VALOR_PEDIDO_LIQUIDO','5.85.000';
GO
