IF EXISTS(SELECT NAME FROM SYSOBJECTS
          WHERE NAME = 'IMPORTA_CONSUMIDOR' AND TYPE = 'P')
  DROP PROCEDURE IMPORTA_CONSUMIDOR
  GO

CREATE PROCEDURE IMPORTA_CONSUMIDOR
  @P_boCdIdConsumid      VARCHAR(1),
  @P_boCdExConsumid      VARCHAR(1),
  @P_boNmConsumidor      VARCHAR(1),
  @P_boVrAviDebCons      VARCHAR(1),
  @P_boVrLimDebCons      VARCHAR(1),
  @P_boDsEndeCons        VARCHAR(1),
  @P_boNmBairCons        VARCHAR(1),
  @P_boNrCepCons         VARCHAR(1),
  @P_boNrTele2Cons       VARCHAR(1),
  @P_boNrTeleCons        VARCHAR(1),
  @P_boNrRamal1Cons      VARCHAR(1),
  @P_boNrRamal2Cons      VARCHAR(1),
  @P_boNrFaxCons         VARCHAR(1),
  @P_boDsEmailCons       VARCHAR(1),
  @P_boVrPeSubCons       VARCHAR(1),
  @P_boVrMeSubCons       VARCHAR(1),
  @P_boCdTipoCons        VARCHAR(1),
  @P_boCdCCusClie        VARCHAR(1),
  @P_boIdVerSaldCon      VARCHAR(1),
  @P_boVrDiaSubCons      VARCHAR(1),
  @P_boCdVendedor        VARCHAR(1),
  @P_boNrRgConsumid      VARCHAR(1),
  @P_boCdSenhaCons       VARCHAR(1),
  @P_boNrCpfRespCon      VARCHAR(1),
  @P_boNmRespCons        VARCHAR(1),
  @P_boNmLoginCons       VARCHAR(1),
  @P_boDtNasCCons        VARCHAR(1),
  @P_boVrMaxDebCons      VARCHAR(1),
  @P_boVrLimCredCons     VARCHAR(1),
  @P_boVrAviCredCons     VARCHAR(1),
  @P_boVrMaxCredCons     VARCHAR(1),
  @P_boCdSenhaSite       VARCHAR(1),
  @P_boNrAcessoSite      VARCHAR(1),
  @P_boCdPais            VARCHAR(1),
  @P_boSgEstado          VARCHAR(1),
  @P_boCdMunicipio       VARCHAR(1),
  @P_boIdTpVendaCons     VARCHAR(1),
  @P_boNrEndeCons        VARCHAR(1),
  @P_boNrCelularCons     VARCHAR(1),
  @P_boDsComplEndeCons   VARCHAR(1),
  @P_boIdImpCpfCupom     VARCHAR(1),
  @P_boIdPerConsProdEx   VARCHAR(1),
  @P_boIdCadConfLibCon   VARCHAR(1),
  @P_boDsReferEndeCons   VARCHAR(1),
  @P_CDFILIAL            VARCHAR(4),
  @P_CDCLIENTE           VARCHAR(500),
  @P_INATIVACONS         VARCHAR(1),
  @P_MODOFILIAL          VARCHAR(1),
  @P_boIdTpSeLManha      VARCHAR(1),
  @P_boIdTpSeLTarde      VARCHAR(1),
  @P_boIdTpSeAlmoco      VARCHAR(1), 
  @P_boVrSubsBasico      VARCHAR(1), 
  @P_boIdBloqSaldFs      VARCHAR(1),
  @P_boCdFamiliSaldImp   VARCHAR(1),
  @P_boVrSaldoCredImp    VARCHAR(1),
  @P_boVrMaxConsMensal   VARCHAR(1)
  
AS

DECLARE @V_CdIdConsumid    VARCHAR(21);
DECLARE @V_CdExConsumid    VARCHAR(21);
DECLARE @V_NmConsumidor    VARCHAR(50);
DECLARE @V_VrAviDebCons    NUMERIC;
DECLARE @V_VrLimDebCons    NUMERIC;
DECLARE @V_DsEndeCons      VARCHAR(50);
DECLARE @V_NmBairCons      VARCHAR(30);
DECLARE @V_NrCepCons       VARCHAR(15);
DECLARE @V_NrTele2Cons     VARCHAR(25);
DECLARE @V_NrTeleCons      VARCHAR(25);
DECLARE @V_NrRamal1Cons    VARCHAR(4);
DECLARE @V_NrRamal2Cons    VARCHAR(4);
DECLARE @V_NrFaxCons       VARCHAR(25);
DECLARE @V_DsEmailCons     VARCHAR(50);
DECLARE @V_VrPeSubCons     NUMERIC;
DECLARE @V_VrMeSubCons     NUMERIC;
DECLARE @V_CdTipoCons      VARCHAR(2);
DECLARE @V_CdCCusClie      VARCHAR(10);
DECLARE @V_IdVerSaldCon    VARCHAR(1);
DECLARE @V_VrDiaSubCons    NUMERIC;
DECLARE @V_NmLoginCons     VARCHAR(30);
DECLARE @V_CdSenhaSite     VARCHAR(40);
DECLARE @V_CdVendedor      VARCHAR(4);
DECLARE @V_NrRgConsumid    VARCHAR(20);
DECLARE @V_CdSenhaCons     VARCHAR(20);
DECLARE @V_NrCpfRespCon    VARCHAR(11);
DECLARE @V_NmRespCons      VARCHAR(50);
DECLARE @V_DtNasCCons      DATE;
DECLARE @V_VrMaxDebCons    NUMERIC;
DECLARE @V_VrLimCredCons   NUMERIC;
DECLARE @V_VrAviCredCons   NUMERIC;
DECLARE @V_VrMaxCredCons   NUMERIC;
DECLARE @V_NrAcessoSite    NUMERIC;
DECLARE @V_CdPais          VARCHAR(4);
DECLARE @V_SgEstado        VARCHAR(2);
DECLARE @V_CdMunicipio     VARCHAR(4);
DECLARE @V_IdTpVendaCons   VARCHAR(1);
DECLARE @V_NrEndeCons      VARCHAR(5);
DECLARE @V_NrCelularCons   VARCHAR(25);
DECLARE @V_DsComplEndeCons VARCHAR(100);
DECLARE @V_IdImpCpfCupom   VARCHAR(1);
DECLARE @V_IdPerConsProdEx VARCHAR(1);
DECLARE @V_IdCadConfLibCon VARCHAR(1);
DECLARE @V_DsReferEndeCons VARCHAR(2000);
DECLARE @V_IdTpSeLManha    VARCHAR(1);
DECLARE @V_IdTpSeLTarde    VARCHAR(1);
DECLARE @V_IdTpSeAlmoco    VARCHAR(1);
DECLARE @V_VrSubsBasico    DECIMAL;
DECLARE @V_IdBloqSaldFs    VARCHAR(1);
DECLARE @V_CdFamiliSaldImp VARCHAR(3);
DECLARE @V_VrSaldoCredImp  DECIMAL;
DECLARE @V_VrMaxConsMensal DECIMAL;

-- DECLARACAO DAS VARIAVEIS DE INSERO --
DECLARE @V_CdIdConsumid_INS    VARCHAR(21);
DECLARE @V_CdExConsumid_INS    VARCHAR(21);
DECLARE @V_NmConsumidor_INS    VARCHAR(50);
DECLARE @V_VrAviDebCons_INS    NUMERIC;
DECLARE @V_VrLimDebCons_INS    NUMERIC;
DECLARE @V_DsEndeCons_INS      VARCHAR(50);
DECLARE @V_NmBairCons_INS      VARCHAR(30);
DECLARE @V_NrCepCons_INS       VARCHAR(15);
DECLARE @V_NrTele2Cons_INS     VARCHAR(25);
DECLARE @V_NrTeleCons_INS      VARCHAR(25);
DECLARE @V_NrRamal1Cons_INS    VARCHAR(4);
DECLARE @V_NrRamal2Cons_INS    VARCHAR(4);
DECLARE @V_NrFaxCons_INS       VARCHAR(25);
DECLARE @V_DsEmailCons_INS     VARCHAR(50);
DECLARE @V_VrPeSubCons_INS     NUMERIC;
DECLARE @V_VrMeSubCons_INS     NUMERIC;
DECLARE @V_CdTipoCons_INS      VARCHAR(2);
DECLARE @V_CdCCusClie_INS      VARCHAR(10);
DECLARE @V_IdVerSaldCon_INS    VARCHAR(1);
DECLARE @V_VrDiaSubCons_INS    NUMERIC;
DECLARE @V_NmLoginCons_INS     VARCHAR(30);
DECLARE @V_CdSenhaSite_INS     VARCHAR(40);
DECLARE @V_CdVendedor_INS      VARCHAR(4);
DECLARE @V_NrRgConsumid_INS    VARCHAR(20);
DECLARE @V_CdSenhaCons_INS     VARCHAR(20);
DECLARE @V_NrCpfRespCon_INS    VARCHAR(11);
DECLARE @V_NmRespCons_INS      VARCHAR(50);
DECLARE @V_DtNasCCons_INS      DATE;
DECLARE @V_VrMaxDebCons_INS    NUMERIC;
DECLARE @V_VrLimCredCons_INS   NUMERIC;
DECLARE @V_VrAviCredCons_INS   NUMERIC;
DECLARE @V_VrMaxCredCons_INS   NUMERIC;
DECLARE @V_NrAcessoSite_INS    NUMERIC;
DECLARE @V_CdPais_INS          VARCHAR(4);
DECLARE @V_SgEstado_INS        VARCHAR(2);
DECLARE @V_CdMunicipio_INS     VARCHAR(4);
DECLARE @V_IdTpVendaCons_INS   VARCHAR(1);
DECLARE @V_NrEndeCons_INS      VARCHAR(5);
DECLARE @V_NrCelularCons_INS   VARCHAR(25);
DECLARE @V_DsComplEndeCons_INS VARCHAR(100);
DECLARE @V_IdImpCpfCupom_INS   VARCHAR(1);
DECLARE @V_IdPerConsProdEx_INS VARCHAR(1);
DECLARE @V_IdCadConfLibCon_INS VARCHAR(1);
DECLARE @V_DsReferEndeCons_INS VARCHAR(2000);
DECLARE @V_IdTpSeLManha_INS    VARCHAR(1);
DECLARE @V_IdTpSeLTarde_INS    VARCHAR(1);
DECLARE @V_IdTpSeAlmoco_INS    VARCHAR(1);
DECLARE @V_VrSubsBasico_INS    DECIMAL;
DECLARE @V_IdBloqSaldFs_INS    VARCHAR(1);
DECLARE @V_CdFamiliSaldImp_INS VARCHAR(3);
DECLARE @V_VrSaldoCredImp_INS  DECIMAL;
DECLARE @V_VrMaxConsMensal_INS  DECIMAL;


-- DECLARACAO DAS VARIAVEIS ATUAIS DO BANCO DE DADOS --
DECLARE @V_CdIdConsumid_ATUAL    VARCHAR(21);
DECLARE @V_CdExConsumid_ATUAL    VARCHAR(21);
DECLARE @V_NmConsumidor_ATUAL    VARCHAR(50);
DECLARE @V_VrAviDebCons_ATUAL    NUMERIC;
DECLARE @V_VrLimDebCons_ATUAL    NUMERIC;
DECLARE @V_DsEndeCons_ATUAL      VARCHAR(50);
DECLARE @V_NmBairCons_ATUAL      VARCHAR(30);
DECLARE @V_NrCepCons_ATUAL       VARCHAR(15);
DECLARE @V_NrTele2Cons_ATUAL     VARCHAR(25);
DECLARE @V_NrTeleCons_ATUAL      VARCHAR(25);
DECLARE @V_NrRamal1Cons_ATUAL    VARCHAR(4);
DECLARE @V_NrRamal2Cons_ATUAL    VARCHAR(4);
DECLARE @V_NrFaxCons_ATUAL       VARCHAR(25);
DECLARE @V_DsEmailCons_ATUAL     VARCHAR(50);
DECLARE @V_VrPeSubCons_ATUAL     NUMERIC;
DECLARE @V_VrMeSubCons_ATUAL     NUMERIC;
DECLARE @V_CdTipoCons_ATUAL      VARCHAR(2);
DECLARE @V_CdCCusClie_ATUAL      VARCHAR(10);
DECLARE @V_IdVerSaldCon_ATUAL    VARCHAR(1);
DECLARE @V_VrDiaSubCons_ATUAL    NUMERIC;
DECLARE @V_NmLoginCons_ATUAL     VARCHAR(30);
DECLARE @V_CdSenhaSite_ATUAL     VARCHAR(40);
DECLARE @V_CdVendedor_ATUAL      VARCHAR(4);
DECLARE @V_NrRgConsumid_ATUAL    VARCHAR(20);
DECLARE @V_CdSenhaCons_ATUAL     VARCHAR(20);
DECLARE @V_NrCpfRespCon_ATUAL    VARCHAR(11);
DECLARE @V_NmRespCons_ATUAL      VARCHAR(50);
DECLARE @V_DtNasCCons_ATUAL      DATE;
DECLARE @V_VrMaxDebCons_ATUAL    NUMERIC;
DECLARE @V_VrLimCredCons_ATUAL   NUMERIC;
DECLARE @V_VrAviCredCons_ATUAL   NUMERIC;
DECLARE @V_VrMaxCredCons_ATUAL   NUMERIC;
DECLARE @V_NrAcessoSite_ATUAL    NUMERIC;
DECLARE @V_CdPais_ATUAL          VARCHAR(4);
DECLARE @V_SgEstado_ATUAL        VARCHAR(2);
DECLARE @V_CdMunicipio_ATUAL     VARCHAR(4);
DECLARE @V_IdTpVendaCons_ATUAL   VARCHAR(1);
DECLARE @V_NrEndeCons_ATUAL      VARCHAR(5);
DECLARE @V_NrCelularCons_ATUAL   VARCHAR(25);
DECLARE @V_DsComplEndeCons_ATUAL VARCHAR(100);
DECLARE @V_IdImpCpfCupom_ATUAL   VARCHAR(1);
DECLARE @V_IdPerConsProdEx_ATUAL VARCHAR(1);
DECLARE @V_IdCadConfLibCon_ATUAL VARCHAR(1);
DECLARE @V_DsReferEndeCons_ATUAL VARCHAR(2000);
DECLARE @V_IdTpSeLManha_ATUAL    VARCHAR(1);
DECLARE @V_IdTpSeLTarde_ATUAL    VARCHAR(1);
DECLARE @V_IdTpSeAlmoco_ATUAL    VARCHAR(1);
DECLARE @V_VrSubsBasico_ATUAL    DECIMAL;
DECLARE @V_IdBloqSaldFs_ATUAL    VARCHAR(1);
DECLARE @V_CdFamiliSaldImp_ATUAL VARCHAR(3);
DECLARE @V_VrSaldoCredImp_ATUAL  DECIMAL;
DECLARE @V_VrMaxConsMensal_ATUAL  DECIMAL;

DECLARE @V_CDCLIENTE        VARCHAR(21);
DECLARE @V_CDCONSUMIDOR     VARCHAR(21);
DECLARE @V_CLIENTE_AUX      VARCHAR(21);
DECLARE @V_CDCLIENTE_FIL    VARCHAR(21);
DECLARE @V_CDCONSUMIDOR_FIL VARCHAR(21);
DECLARE @V_TIPOCONS_AUX     VARCHAR(2);
DECLARE @V_CENTRO_CUSTO     VARCHAR(10);
DECLARE @V_CONTADOR         NUMERIC;
DECLARE @V_NRREG            NUMERIC;
DECLARE @V_NRREG_AUX        NUMERIC;

BEGIN
   DECLARE CUR_CLIENTE CURSOR FOR
      SELECT DISTINCT CDCLIENTETRAB
      FROM   TRABCONSUMIDOR;
   OPEN CUR_CLIENTE;
   FETCH NEXT FROM CUR_CLIENTE INTO @V_CLIENTE_AUX;

   WHILE (@@FETCH_STATUS = 0 ) BEGIN

      DECLARE CUR_CENTRO CURSOR FOR
         SELECT DISTINCT CDCCUSCLIETRAB
         FROM   TRABCONSUMIDOR
         WHERE  CDCLIENTETRAB = @V_CLIENTE_AUX
           AND  CDCCUSCLIETRAB NOT IN (SELECT CDCCUSCLIE FROM CCUSCLIE WHERE CDCLIENTE = @V_CLIENTE_AUX);
      OPEN CUR_CENTRO;
      FETCH NEXT FROM CUR_CENTRO INTO @V_CENTRO_CUSTO;
      WHILE (@@FETCH_STATUS = 0 ) BEGIN
         INSERT INTO CCLUSCLIE
          (CDCLIENTE,CDCCUSCLIE,NMCCUSCLIE,DTULTATUCUSC)
         VALUES
          (@V_CLIENTE_AUX,@V_CENTRO_CUSTO,'IMP.AUTOMATICA',GETDATE());
         FETCH NEXT FROM CUR_CENTRO INTO @V_CENTRO_CUSTO;
      END;
      CLOSE CUR_CENTRO;
      DEALLOCATE CUR_CENTRO;
      FETCH NEXT FROM CUR_CLIENTE INTO @V_CLIENTE_AUX;
   END;
   CLOSE CUR_CLIENTE;
   DEALLOCATE CUR_CLIENTE;

   DECLARE CUR_TIPOCONS CURSOR FOR
   SELECT DISTINCT CDTIPOCONSTRAB
   FROM TRABCONSUMIDOR
   WHERE CDTIPOCONSTRAB NOT IN (SELECT CDTIPOCONS FROM TIPOCONS)

   OPEN CUR_TIPOCONS;
   FETCH NEXT FROM CUR_TIPOCONS INTO @V_TIPOCONS_AUX;
      WHILE (@@FETCH_STATUS = 0 ) BEGIN
         INSERT INTO TIPOCONS
         (CDTIPOCONS,NMTIPOCONS,DTULTATUTCON,IDREGDUPCATR)
          VALUES
         (@V_TIPOCONS_AUX,'IMP.AUTOMATICA',GETDATE(),'SSSSSSSSSSSSSSSSSSSS');   
         FETCH NEXT FROM CUR_TIPOCONS INTO @V_CENTRO_CUSTO;
      END;  
   CLOSE CUR_TIPOCONS;
   DEALLOCATE CUR_TIPOCONS;
   COMMIT;

   SET @V_CONTADOR = 0;

   DECLARE CUR_CONS CURSOR FOR
      SELECT CDCLIENTETRAB       , CDCONSUMIDORTRAB    , CDIDCONSUMIDTRAB  , CDEXCONSUMIDTRAB    ,
             NMCONSUMIDORTRAB    , VRAVIDEBCONSTRAB    , VRLIMDEBCONSTRAB  , DSENDECONSTRAB      ,
             NMBAIRCONSTRAB      , NRCEPCONSTRAB       , NRTELE2CONSTRAB   , NRTELECONSTRAB      ,
             NRRAMAL1CONSTRAB    , NRRAMAL2CONSTRAB    , NRFAXCONSTRAB     , DSEMAILCONSTRAB     ,
             VRPESUBCONSTRAB     , VRMESUBCONSTRAB     , CDTIPOCONSTRAB    , CDCCUSCLIETRAB      ,
             IDVERSALDCONTRAB    , VRDIASUBCONSTRAB    , NMLOGINCONSTRAB   , CDSENHASITETRAB     ,
             CDVENDEDORTRAB      , NRRGCONSUMIDTRAB    , CDSENHACONSTRAB   , NRCPFRESPCONTRAB    ,
             NMRESPCONSTRAB      , DTNASCCONSTRAB      , VRMAXDEBCONSTRAB  , VRLIMCREDCONSTRAB   ,
             VRAVICREDCONSTRAB   , VRMAXCREDCONSTRAB   , NRACESSOSITETRAB  , CDPAISTRAB          ,
             SGESTADOTRAB        , CDMUNICIPIOTRAB     , IDTPVENDACONSTRAB , NRENDECONSTRAB      ,
             NRCELULARCONSTRAB   , DSCOMPLENDECONSTRAB , IDIMPCPFCUPOMTRAB , IDPERCONSPRODEXTRAB ,
             IDCADCONFLIBCONTRAB , DSREFERENDECONSTRAB , IDTPSELMANHATRAB  , IDTPSELTARDETRAB    ,
             IDTPSEALMOCOTRAB    , VRSUBSBASICOTRAB    , IDBLOQSALDFSTRAB  , CDFAMILISALDIMPTRAB ,
             VRSALDOCREDIMPTRAB  , VRMAXCONSMENSALTRAB
      FROM   TRABCONSUMIDOR;

   OPEN CUR_CONS;
   FETCH NEXT FROM CUR_CONS INTO
              @V_CDCLIENTE       , @V_CDCONSUMIDOR    , @V_CDIDCONSUMID  , @V_CDEXCONSUMID    ,
              @V_NMCONSUMIDOR    , @V_VRAVIDEBCONS    , @V_VRLIMDEBCONS  , @V_DSENDECONS      ,
              @V_NMBAIRCONS      , @V_NRCEPCONS       , @V_NRTELE2CONS   , @V_NRTELECONS      ,
              @V_NRRAMAL1CONS    , @V_NRRAMAL2CONS    , @V_NRFAXCONS     , @V_DSEMAILCONS     ,
              @V_VRPESUBCONS     , @V_VRMESUBCONS     , @V_CDTIPOCONS    , @V_CDCCUSCLIE      ,
              @V_IDVERSALDCON    , @V_VRDIASUBCONS    , @V_NmLoginCons   , @V_CdSenhaSite     ,
              @V_CdVendedor      , @V_NrRgConsumid    , @V_CdSenhaCons   , @V_NrCpfRespCon    ,
              @V_NmRespCons      , @V_DtNasCCons      , @V_VrMaxDebCons  , @V_VrLimCredCons   ,
              @V_VrAviCredCons   , @V_VrMaxCredCons   , @V_NrAcessoSite  , @V_CdPais          ,
              @V_SgEstado        , @V_CdMunicipio     , @V_IdTpVendaCons , @V_NrEndeCons      ,
              @V_NrCelularCons   , @V_DsComplEndeCons , @V_IdImpCpfCupom , @V_IdPerConsProdEx ,
              @V_IdCadConfLibCon , @V_DsReferEndeCons , @P_boIdTpSeLManha, @P_boIdTpSeLTarde  ,
 	          @P_boIdTpSeAlmoco  , @P_boVrSubsBasico  , @P_boIdBloqSaldFs, @P_boCdFamiliSaldImp,
	          @P_boVrSaldoCredImp, @P_boVrMaxConsMensal

   WHILE (@@FETCH_STATUS = 0 ) BEGIN

      IF @V_CONTADOR > 300 BEGIN
         SET @V_CONTADOR = 0;
      END;

      SELECT @V_NRREG = COUNT(*)
        FROM CONSUMIDOR
       WHERE CDCLIENTE = @V_CDCLIENTE
         AND CDCONSUMIDOR = @V_CDCONSUMIDOR;

      IF @V_NRREG > 0 BEGIN
         SELECT @V_CdIdConsumid_ATUAL    = CdIdConsumid,
                @V_CdExConsumid_ATUAL    = CdExConsumid,
                @V_NmConsumidor_ATUAL    = NmConsumidor,
                @V_VrAviDebCons_ATUAL    = VrAviDebCons,
                @V_VrLimDebCons_ATUAL    = VrLimDebCons,
                @V_DsEndeCons_ATUAL      = DsEndeCons,
                @V_NmBairCons_ATUAL      = NmBairCons,
                @V_NrCepCons_ATUAL       = NrCepCons,
                @V_NrTele2Cons_ATUAL     = NrTele2Cons,
                @V_NrTeleCons_ATUAL      = NrTeleCons,
                @V_NrRamal1Cons_ATUAL    = NrRamal1Cons,
                @V_NrRamal2Cons_ATUAL    = NrRamal2Cons,
                @V_NrFaxCons_ATUAL       = NrFaxCons,
                @V_DsEmailCons_ATUAL     = DsEmailCons,
                @V_VrPeSubCons_ATUAL     = VrPeSubCons,
                @V_VrMeSubCons_ATUAL     = VrMeSubCons,
                @V_CdTipoCons_ATUAL      = CdTipoCons ,
                @V_CdCCusClie_ATUAL      = CdCCusClie ,
                @V_IdVerSaldCon_ATUAL    = IdVerSaldCon,
                @V_VrDiaSubCons_ATUAL    = VrDiaSubCons,
                @V_NmLoginCons_ATUAL     = NmLoginCons,
                @V_CdSenhaSite_ATUAL     = CdSenhaSite,
                @V_CdVendedor_ATUAL      = CdVendedor,
                @V_NrRgConsumid_ATUAL    = NrRgConsumid,
                @V_CdSenhaCons_ATUAL     = CdSenhaCons,
                @V_NrCpfRespCon_ATUAL    = NrCpfRespCon,
                @V_NmRespCons_ATUAL      = NmRespCons,
                @V_DtNascCons_ATUAL      = DtNascCons,
                @V_VrMaxDebCons_ATUAL    = VrMaxDebCons,
                @V_VrLimCredCons_ATUAL   = VrLimCredCons,
                @V_VrAviCredCons_ATUAL   = VrAviCredCons,
                @V_VrMaxCredCons_ATUAL   = VrMaxCredCons,
                @V_NrAcessoSite_ATUAL    = NrAcessoSite,
                @V_CdPais_ATUAL          = CdPais,
                @V_SgEstado_ATUAL        = SgEstado,
                @V_CdMunicipio_ATUAL     = CdMunicipio,
                @V_IdTpVendaCons_ATUAL   = IdTpVendaCons,
                @V_NrEndeCons_ATUAL      = NrEndeCons,
                @V_NrCelularCons_ATUAL   = NrCelularCons,
                @V_DsComplEndeCons_ATUAL = DsComplEndeCons,
                @V_IdImpCpfCupom_ATUAL   = IdImpCpfCupom,
                @V_IdPerConsProdEx_ATUAL = IdPerConsProdEx,
                @V_IdCadConfLibCon_ATUAL = IdCadConfLibCon,
                @V_DsReferEndeCons_ATUAL = DsReferEndeCons,
        		@V_IdTpSeLManha_ATUAL    = IdTpSeLManha,
		        @V_IdTpSeLTarde_ATUAL    = IdTpSeLTarde,
		        @V_IdTpSeAlmoco_ATUAL    = IdTpSeAlmoco,
		        @V_VrSubsBasico_ATUAL    = VrSubsBasico,
		        @V_IdBloqSaldFs_ATUAL    = IdBloqSaldFs,
		        @V_CdFamiliSaldImp_ATUAL = CdFamiliSaldImp,
		        @V_VrSaldoCredImp_ATUAL  = VrSaldoCredImp,
		        @V_VrMaxConsMensal_ATUAL = VrMaxConsMensal
         FROM CONSUMIDOR
         WHERE CDCLIENTE    = @V_CDCLIENTE
           AND CDCONSUMIDOR = @V_CDCONSUMIDOR;

         IF (@P_boCdIdConsumid = 'S') BEGIN
            SET @V_CDIDCONSUMID_INS = @V_CDIDCONSUMID;
         END ELSE BEGIN
            SET @V_CDIDCONSUMID_INS = @V_CDIDCONSUMID_ATUAL;
         END;

         IF (@P_boCdExConsumid = 'S') BEGIN
            SET @V_CdExConsumid_INS = @V_CdExConsumid;
         END ELSE BEGIN
            SET @V_CdExConsumid_INS = @V_CdExConsumid_ATUAL;
         END;

         IF (@P_boNmConsumidor = 'S') BEGIN
            SET @V_NmConsumidor_INS = @V_NmConsumidor;
         END ELSE BEGIN
            SET @V_NmConsumidor_INS = @V_NmConsumidor_ATUAL;
         END;

         IF (@P_boVrAviDebCons = 'S') BEGIN
            SET @V_VrAviDebCons_INS = @V_VrAviDebCons;
         END ELSE BEGIN
            SET @V_VrAviDebCons_INS = @V_VrAviDebCons_ATUAL;
         END;

         IF (@P_boVrLimDebCons = 'S') BEGIN
            SET @V_VrLimDebCons_INS = @V_VrLimDebCons;
         END ELSE BEGIN
            SET @V_VrLimDebCons_INS = @V_VrLimDebCons_ATUAL;
         END;

         IF (@P_boDsEndeCons = 'S') BEGIN
            SET @V_DsEndeCons_INS = @V_DsEndeCons;
         END ELSE BEGIN
            SET @V_DsEndeCons_INS = @V_DsEndeCons_ATUAL;
         END;

         IF (@P_boNmBairCons = 'S') BEGIN
            SET @V_NmBairCons_INS = @V_NmBairCons;
         END ELSE BEGIN
            SET @V_NmBairCons_INS = @V_NmBairCons_ATUAL;
         END;

         IF (@P_boNrCepCons = 'S') BEGIN
            SET @V_NrCepCons_INS = @V_NrCepCons;
         END ELSE BEGIN
            SET @V_NrCepCons_INS = @V_NrCepCons_ATUAL;
         END;

         IF (@P_boNrTele2Cons = 'S') BEGIN
            SET @V_NrTele2Cons_INS = @V_NrTele2Cons;
         END ELSE BEGIN
            SET @V_NrTele2Cons_INS = @V_NrTele2Cons_ATUAL;
         END;

         IF (@P_boNrTeleCons = 'S') BEGIN
            SET @V_NrTeleCons_INS = @V_NrTeleCons;
         END ELSE BEGIN
            SET @V_NrTeleCons_INS = @V_NrTeleCons_ATUAL;
         END;

         IF (@P_boNrRamal1Cons = 'S') BEGIN
            SET @V_NrRamal1Cons_INS = @V_NrRamal1Cons;
         END ELSE BEGIN
            SET @V_NrRamal1Cons_INS = @V_NrRamal1Cons_ATUAL;
         END;

         IF (@P_boNrRamal2Cons = 'S') BEGIN
            SET @V_NrRamal2Cons_INS = @V_NrRamal2Cons;
         END ELSE BEGIN
            SET @V_NrRamal2Cons_INS = @V_NrRamal2Cons_ATUAL;
         END;

         IF (@P_boNrFaxCons = 'S') BEGIN
            SET @V_NrFaxCons_INS = @V_NrFaxCons;
         END ELSE BEGIN
            SET @V_NrFaxCons_INS = @V_NrFaxCons_ATUAL;
         END;

         IF (@P_boDsEmailCons = 'S') BEGIN
            SET @V_DsEmailCons_INS = @V_DsEmailCons;
         END ELSE BEGIN
            SET @V_DsEmailCons_INS = @V_DsEmailCons_ATUAL;
         END;

         IF (@P_boVrPeSubCons = 'S') BEGIN
            SET @V_VrPeSubCons_INS = @V_VrPeSubCons;
         END ELSE BEGIN
            SET @V_VrPeSubCons_INS = @V_VrPeSubCons_ATUAL;
         END;

         IF (@P_boVrMeSubCons = 'S') BEGIN
            SET @V_VrMeSubCons_INS = @V_VrMeSubCons;
         END ELSE BEGIN
            SET @V_VrMeSubCons_INS = @V_VrMeSubCons_ATUAL;
         END;

         IF (@P_boVrDiaSubCons = 'S') BEGIN
            SET @V_VrDiaSubCons_INS = @V_VrDiaSubCons;
         END ELSE BEGIN
            SET @V_VrDiaSubCons_INS = @V_VrDiaSubCons_ATUAL;
         END;

         IF (@P_boCdTipoCons = 'S') BEGIN
            SET @V_CdTipoCons_INS = @V_CdTipoCons;
         END ELSE BEGIN
            SET @V_CdTipoCons_INS = @V_CdTipoCons_ATUAL;
         END;

         IF (@P_boCdCCusClie = 'S') BEGIN
            SET @V_CdCCusClie_INS = @V_CdCCusClie;
         END ELSE BEGIN
            SET @V_CdCCusClie_INS = @V_CdCCusClie_ATUAL;
         END;

         IF (@P_boIdVerSaldCon = 'S') BEGIN
            SET @V_IdVerSaldCon_INS = @V_IdVerSaldCon;
         END ELSE BEGIN
            SET @V_IdVerSaldCon_INS = @V_IdVerSaldCon_ATUAL;
         END;

         IF (@P_boNmLoginCons = 'S') BEGIN
            SET @V_NmLoginCons_INS = @V_NmLoginCons;
         END ELSE BEGIN
            SET @V_NmLoginCons_INS = @V_NmLoginCons_ATUAL;
         END;

         IF (@P_boCdSenhaSite = 'S') BEGIN
            SET @V_CdSenhaSite_INS = @V_CdSenhaSite;
         END ELSE BEGIN
            SET @V_CdSenhaSite_INS = @V_CdSenhaSite_ATUAL;
         END;

         IF (@P_boCdVendedor = 'S') BEGIN
            SET @V_CdVendedor_INS = @V_CdVendedor;
         END ELSE BEGIN
            SET @V_CdVendedor_INS = @V_CdVendedor_ATUAL;
         END;

         IF (@P_boNrRgConsumid = 'S') BEGIN
            SET @V_NrRgConsumid_INS = @V_NrRgConsumid;
         END ELSE BEGIN
            SET @V_NrRgConsumid_INS = @V_NrRgConsumid_ATUAL;
         END;

         IF (@P_boCdSenhaCons = 'S') BEGIN
            SET @V_CdSenhaCons_INS = @V_CdSenhaCons;
         END ELSE BEGIN
            SET @V_CdSenhaCons_INS = @V_CdSenhaCons_ATUAL;
         END;

         IF (@P_boNrCpfRespCon = 'S') BEGIN
            SET @V_NrCpfRespCon_INS = @V_NrCpfRespCon;
         END ELSE BEGIN
            SET @V_NrCpfRespCon_INS = @V_NrCpfRespCon_ATUAL;
         END;

         IF (@P_boNmRespCons = 'S') BEGIN
            SET @V_NmRespCons_INS = @V_NmRespCons;
         END ELSE BEGIN
            SET @V_NmRespCons_INS = @V_NmRespCons_ATUAL;
         END;

         IF (@P_boDtNasCCons = 'S') BEGIN
            SET @V_DtNasCCons_INS = @V_DtNasCCons;
         END ELSE BEGIN
            SET @V_DtNasCCons_INS = @V_DtNasCCons_ATUAL;
         END;

         IF (@P_boVrMaxDebCons = 'S') BEGIN
            SET @V_VrMaxDebCons_INS = @V_VrMaxDebCons;
         END ELSE BEGIN
            SET @V_VrMaxDebCons_INS = @V_VrMaxDebCons_ATUAL;
         END;

         IF (@P_boVrLimCredCons = 'S') BEGIN
            SET @V_VrLimCredCons_INS = @V_VrLimCredCons;
         END ELSE BEGIN
            SET @V_VrLimCredCons_INS = @V_VrLimCredCons_ATUAL;
         END;

         IF (@P_boVrAviCredCons = 'S') BEGIN
            SET @V_VrAviCredCons_INS = @V_VrAviCredCons;
         END ELSE BEGIN
            SET @V_VrAviCredCons_INS = @V_VrAviCredCons_ATUAL;
         END;

         IF (@P_boVrMaxCredCons = 'S') BEGIN
            SET @V_VrMaxCredCons_INS = @V_VrMaxCredCons;
         END ELSE BEGIN
            SET @V_VrMaxCredCons_INS = @V_VrMaxCredCons_ATUAL;
         END;

         IF (@P_boNrAcessoSite = 'S') BEGIN
            SET @V_NrAcessoSite_INS = @V_NrAcessoSite;
         END ELSE BEGIN
            SET @V_NrAcessoSite_INS = @V_NrAcessoSite_ATUAL;
         END;

         IF (@P_boCdPais = 'S') BEGIN
            SET @V_CdPais_INS = @V_CdPais;
         END ELSE BEGIN
            SET @V_CdPais_INS = @V_CdPais_ATUAL;
         END;

         IF (@P_boSgEstado = 'S') BEGIN
            SET @V_SgEstado_INS = @V_SgEstado;
         END ELSE BEGIN
            SET @V_SgEstado_INS = @V_SgEstado_ATUAL;
         END;

         IF (@P_boCdMunicipio = 'S') BEGIN
            SET @V_CdMunicipio_INS = @V_CdMunicipio;
         END ELSE BEGIN
            SET @V_CdMunicipio_INS = @V_CdMunicipio_ATUAL;
         END;

         IF (@P_boIdTpVendaCons = 'S') BEGIN
            SET @V_IdTpVendaCons_INS = @V_IdTpVendaCons;
         END ELSE BEGIN
            SET @V_IdTpVendaCons_INS = @V_IdTpVendaCons_ATUAL;
         END;

         IF (@P_boNrEndeCons = 'S') BEGIN
            SET @V_NrEndeCons_INS = @V_NrEndeCons;
         END ELSE BEGIN
            SET @V_NrEndeCons_INS = @V_NrEndeCons_ATUAL;
         END;

         IF (@P_boNrCelularCons = 'S') BEGIN
            SET @V_NrCelularCons_INS = @V_NrCelularCons;
         END ELSE BEGIN
            SET @V_NrCelularCons_INS = @V_NrCelularCons_ATUAL;
         END;

         IF (@P_boDsComplEndeCons = 'S') BEGIN
            SET @V_DsComplEndeCons_INS = @V_DSCOMPLENDECONS;
         END ELSE BEGIN
            SET @V_DsComplEndeCons_INS = @V_DsComplEndeCons_ATUAL;
         END;

         IF (@P_boIdImpCpfCupom = 'S') BEGIN
            SET @V_IdImpCpfCupom_INS = @V_IDIMPCPFCUPOM;
         END ELSE BEGIN
            SET @V_IdImpCpfCupom_INS = @V_IdImpCpfCupom_ATUAL;
         END;

         IF (@P_boIdPerConsProdEx = 'S') BEGIN
            SET @V_IdPerConsProdEx_INS = @V_IDPERCONSPRODEX;
         END ELSE BEGIN
            SET @V_IdPerConsProdEx_INS = @V_IdPerConsProdEx_ATUAL;
         END;

         IF (@P_boIdCadConfLibCon = 'S') BEGIN
            SET @V_IdCadConfLibCon_INS = @V_IDCADCONFLIBCON;
         END ELSE BEGIN
            SET @V_IdCadConfLibCon_INS = @V_IdCadConfLibCon_ATUAL;
         END;

         IF (@P_boDsReferEndeCons = 'S') BEGIN
            SET @V_DsReferEndeCons_INS = @V_DSREFERENDECONS ;
         END ELSE BEGIN
            SET @V_DsReferEndeCons_INS = @V_DsReferEndeCons_ATUAL;
         END;

         IF (@P_IdTpSeLManha = 'S') BEGIN
            SET @V_IdTpSeLManha_INS = @V_IdTpSeLManha;	
	 END ELSE BEGIN
	    SET @V_IdTpSeLManha_INS = @V_IdTpSeLManha_ATUAL;
	 END;
	
	 IF (@P_IdTpSeLTarde = 'S') BEGIN
            SET @V_IdTpSeLTarde_INS = @V_IdTpSeLTarde;
	 END ELSE BEGIN
	    SET @V_IdTpSeLTarde_INS = @V_IdTpSeLTarde_ATUAL;
	 END;
	
	 IF (@P_IdTpSeAlmoco = 'S') BEGIN
            SET @V_IdTpSeAlmoco_INS = @V_IdTpSeAlmoco;
	 END ELSE BEGIN
	    SET @V_IdTpSeAlmoco_INS = @V_IdTpSeAlmoco_ATUAL;
	 END;
	
	 IF (@P_VrSubsBasico = 'S') BEGIN
            SET @V_VrSubsBasico_INS = @V_VrSubsBasico;
	 END ELSE BEGIN
	    SET @V_VrSubsBasico_INS = @V_VrSubsBasico_ATUAL;
	 END;
	
	 IF (@P_IdBloqSaldFs = 'S') BEGIN
            SET @V_IdBloqSaldFs_INS = @V_IdBloqSaldFs;
	 END ELSE BEGIN
	    SET @V_IdBloqSaldFs_INS = @V_IdBloqSaldFs_ATUAL;
	 END;

	 IF (@P_CdFamiliSaldImp = 'S') BEGIN
            SET @V_CdFamiliSaldImp_INS = @V_CdFamiliSaldImp;
	 END ELSE BEGIN
	    SET @V_CdFamiliSaldImp_INS = @V_CdFamiliSaldImp_ATUAL;
	 END;
	
	 IF (@P_VrSaldoCredImp = 'S') BEGIN
            SET @V_VrSaldoCredImp_INS = @V_VrSaldoCredImp;
	 END ELSE BEGIN
	    SET @V_VrSaldoCredImp_INS = @V_VrSaldoCredImp_ATUAL;
	 END;

	 IF (@P_VrMaxConsMensal = 'S') BEGIN
            SET @V_VrMaxConsMensal_INS = @V_VrMaxConsMensal;
	 END ELSE BEGIN
	    SET @V_VrMaxConsMensal_INS = @V_VrMaxConsMensal_ATUAL;
	 END;

	 
         UPDATE CONSUMIDOR
         SET VRMESUBCONS     = @V_VRMESUBCONS_INS,
             VRPESUBCONS     = @V_VRPESUBCONS_INS,
             NMCONSUMIDOR    = @V_NMCONSUMIDOR_INS,
             CDIDCONSUMID    = @V_CDIDCONSUMID_INS,
             CDEXCONSUMID    = @V_CDEXCONSUMID_INS,
             VRAVIDEBCONS    = @V_VRAVIDEBCONS_INS,
             VRLIMDEBCONS    = @V_VRLIMDEBCONS_INS,
             DSENDECONS      = @V_DSENDECONS_INS,
             NMBAIRCONS      = @V_NMBAIRCONS_INS,
             NRCEPCONS       = @V_NRCEPCONS_INS,
             NRTELE2CONS     = @V_NRTELE2CONS_INS,
             NRTELECONS      = @V_NRTELECONS_INS,
             NRRAMAL1CONS    = @V_NRRAMAL1CONS_INS,
             NRRAMAL2CONS    = @V_NRRAMAL2CONS_INS,
             NRFAXCONS       = @V_NRFAXCONS_INS,
             DSEMAILCONS     = @V_DSEMAILCONS_INS,
             CDTIPOCONS      = @V_CDTIPOCONS_INS,
             CDCCUSCLIE      = @V_CDCCUSCLIE_INS,
             IDSITCONSUMI    = '1',
             IDVERSALDCON    = @V_IDVERSALDCON_INS,
             DTULTATUCSUM    = GETDATE(),
             VRDIASUBCONS    = @V_VRDIASUBCONS_INS,
             CDVENDEDOR      = @V_CDVENDEDOR_INS,
             NRRGCONSUMID    = @V_NRRGCONSUMID_INS,
             CDSENHACONS     = @V_CDSENHACONS_INS,
             NRCPFRESPCON    = @V_NRCPFRESPCON_INS,
             NMRESPCONS      = @V_NMRESPCONS_INS,
             NMLOGINCONS     = @V_NMLOGINCONS_INS,
             DTNASCCONS      = @V_DTNASCCONS_INS,
             VRMAXDEBCONS    = @V_VRMAXDEBCONS_INS,
             VRLIMCREDCONS   = @V_VRLIMCREDCONS_INS,
             VRAVICREDCONS   = @V_VRAVICREDCONS_INS,
             VRMAXCREDCONS   = @V_VRMAXCREDCONS_INS,
             CDSENHASITE     = @V_CDSENHASITE_INS,
             NRACESSOSITE    = @V_NRACESSOSITE_INS,
             CDPAIS          = @V_CDPAIS_INS,
             SGESTADO        = @V_SGESTADO_INS,
             CDMUNICIPIO     = @V_CDMUNICIPIO_INS,
             IDTPVENDACONS   = @V_IDTPVENDACONS_INS,
             NRENDECONS      = @V_NRENDECONS_INS,
             NRCELULARCONS   = @V_NRCELULARCONS_INS,
             DSCOMPLENDECONS = @V_DSCOMPLENDECONS_INS,
             IDIMPCPFCUPOM   = @V_IDIMPCPFCUPOM_INS,
             IDPERCONSPRODEX = @V_IDPERCONSPRODEX_INS,
             IDCADCONFLIBCON = @V_IDCADCONFLIBCON_INS,
             DSREFERENDECONS = @V_DSREFERENDECONS_INS,
	         IDTPSELMANHA    = @V_IDTPSELMANHA_INS,
             IDTPSELTARDE    = @V_IDTPSELTARDE_INS,
             IDTPSEALMOCO    = @V_IDTPSEALMOCO_INS,
             VRSUBSBASICO    = @V_VRSUBSBASICO_INS,
             IDBLOQSALDFS    = @V_IDBLOQSALDFS_INS,
	         CDFAMILISALDIMP = @V_CDFAMILISALDIMP_INS,
             VRSALDOCREDIMP  = @V_VRSALDOCREDIMP_INS,
			 VRMAXCONSMENSAL = @V_VRMAXCONSMENSAL_INS
         WHERE CDCLIENTE    = @V_CDCLIENTE
           AND CDCONSUMIDOR = @V_CDCONSUMIDOR;
      END ELSE BEGIN
         INSERT INTO CONSUMIDOR
            (CDCLIENTE       , CDCONSUMIDOR    , CDIDCONSUMID  , CDEXCONSUMID    ,
             NMCONSUMIDOR    , VRAVIDEBCONS    , VRLIMDEBCONS  , DSENDECONS      ,
             NMBAIRCONS      , NRCEPCONS       , NRTELE2CONS   , NRTELECONS      ,
             NRRAMAL1CONS    , NRRAMAL2CONS    , NRFAXCONS     , DSEMAILCONS     ,
             VRPESUBCONS     , VRMESUBCONS     , CDTIPOCONS    , CDCCUSCLIE      ,
             IDVERSALDCON    , VRDIASUBCONS    , CDVENDEDOR    , NRRGCONSUMID    ,
             CDSENHACONS     , NRCPFRESPCON    , NMRESPCONS    , NMLOGINCONS     ,
             DTNASCCONS      , VRMAXDEBCONS    , VRLIMCREDCONS , VRAVICREDCONS   ,
             VRMAXCREDCONS   , CDSENHASITE     , NRACESSOSITE  , CDPAIS          ,
             SGESTADO        , CDMUNICIPIO     , IDTPVENDACONS , NRENDECONS      ,
             NRCELULARCONS   , DSCOMPLENDECONS , IDIMPCPFCUPOM , IDPERCONSPRODEX ,
             IDCADCONFLIBCON , DSREFERENDECONS , IDTPSELMANHA  , IDTPSELTARDE    ,
             IDTPSEALMOCO    , VRSUBSBASICO    , IDBLOQSALDFS  , CDFAMILISALDIMP ,
             VRSALDOCREDIMP  , VRMAXCONSMENSAL)
         VALUES
            (@V_CDCLIENTE       , @V_CDCONSUMIDOR    , @V_CDIDCONSUMID  , @V_CDEXCONSUMID    ,
             @V_NMCONSUMIDOR    , @V_VRAVIDEBCONS    , @V_VRLIMDEBCONS  , @V_DSENDECONS      ,
             @V_NMBAIRCONS      , @V_NRCEPCONS       , @V_NRTELE2CONS   , @V_NRTELECONS      ,
             @V_NRRAMAL1CONS    , @V_NRRAMAL2CONS    , @V_NRFAXCONS     , @V_DSEMAILCONS     ,
             @V_VRPESUBCONS     , @V_VRMESUBCONS     , @V_CDTIPOCONS    , @V_CDCCUSCLIE      ,
             @V_IDVERSALDCON    , @V_VRDIASUBCONS    , @V_CDVENDEDOR    , @V_NRRGCONSUMID    ,
             @V_CDSENHACONS     , @V_NRCPFRESPCON    , @V_NMRESPCONS    , @V_NMLOGINCONS     ,
             @V_DTNASCCONS      , @V_VRMAXDEBCONS    , @V_VRLIMCREDCONS , @V_VRAVICREDCONS   ,
             @V_VRMAXCREDCONS   , @V_CDSENHASITE     , @V_NRACESSOSITE  , @V_CDPAIS          ,
             @V_SGESTADO        , @V_CDMUNICIPIO     , @V_IDTPVENDACONS , @V_NRENDECONS      ,
             @V_NRCELULARCONS   , @V_DSCOMPLENDECONS , @V_IDIMPCPFCUPOM , @V_IDPERCONSPRODEX ,
             @V_IDCADCONFLIBCON , @V_DSREFERENDECONS , @V_IDTPSELMANHA  , @V_IDTPSELTARDE    ,
             @V_IDTPSEALMOCO    , @V_VRSUBSBASICO    , @V_IDBLOQSALDFS  , @V_CDFAMILISALDIMP ,
             @V_VRSALDOCREDIMP  , @V_VRMAXCONSMENSAL);
      END;

      /* TRATAMENTO DA CONSUMIFILIAL - SOLICITAO 108140 */
      /* INSERE A FILIAL DO CONSUMIDOR */
      IF @P_MODOFILIAL = 'S' BEGIN
         SELECT  @V_NRREG = COUNT(*)
           FROM  CONSUMIFILIAL
          WHERE  CDCLIENTE     = @V_CDCLIENTE
            AND  CDCONSUMIDOR  = @V_CDCONSUMIDOR
            AND  CDFILIAL      = @P_CDFILIAL;

         IF @V_NRREG = 0 BEGIN
            INSERT INTO CONSUMIFILIAL
               (CDCLIENTE,CDCONSUMIDOR,CDFILIAL)
            VALUES
               (@V_CDCLIENTE, @V_CDCONSUMIDOR, @P_CDFILIAL);
         END;
      END;

      /* UPDATA O CRACHA COM O CODIGO DO CONSUMIDOR */
      UPDATE CONSUMIDOR
         SET CDIDCONSUMID  = @V_CDCONSUMIDOR
       WHERE CDCLIENTE     = @V_CDCLIENTE
         AND CDCONSUMIDOR  = @V_CDCONSUMIDOR
         AND CDIDCONSUMID IS NULL;

      COMMIT;

      SET @V_CONTADOR = @V_CONTADOR + 1;

      FETCH NEXT FROM CUR_CONS INTO
              @V_CDCLIENTE       , @V_CDCONSUMIDOR    , @V_CDIDCONSUMID  , @V_CDEXCONSUMID    ,
              @V_NMCONSUMIDOR    , @V_VRAVIDEBCONS    , @V_VRLIMDEBCONS  , @V_DSENDECONS      ,
              @V_NMBAIRCONS      , @V_NRCEPCONS       , @V_NRTELE2CONS   , @V_NRTELECONS      ,
              @V_NRRAMAL1CONS    , @V_NRRAMAL2CONS    , @V_NRFAXCONS     , @V_DSEMAILCONS     ,
              @V_VRPESUBCONS     , @V_VRMESUBCONS     , @V_CDTIPOCONS    , @V_CDCCUSCLIE      ,
              @V_IDVERSALDCON    , @V_VRDIASUBCONS    , @V_NmLoginCons   , @V_CdSenhaSite     ,
              @V_CdVendedor      , @V_NrRgConsumid    , @V_CdSenhaCons   , @V_NrCpfRespCon    ,
              @V_NmRespCons      , @V_DtNasCCons      , @V_VrMaxDebCons  , @V_VrLimCredCons   ,
              @V_VrAviCredCons   , @V_VrMaxCredCons   , @V_NrAcessoSite  , @V_CdPais          ,
              @V_SgEstado        , @V_CdMunicipio     , @V_IdTpVendaCons , @V_NrEndeCons      ,
              @V_NrCelularCons   , @V_DsComplEndeCons , @V_IdImpCpfCupom , @V_IdPerConsProdEx ,
              @V_IdCadConfLibCon , @V_DsReferEndeCons , @V_boIdTpSeLManha, @V_boIdTpSeLTarde  ,
	          @V_boIdTpSeAlmoco  , @V_boVrSubsBasico  , @V_boIdBloqSaldFs, @V_boCdFamiliSaldImp,
	          @V_boVrSaldoCredImp, @V_VrMaxConsMensal ;

   END;
   CLOSE CUR_CONS;
   DEALLOCATE CUR_CONS;

   /* TRATAMENTO DA INATIVAO DOS CONSUMIDORES QUE NO VIERAM NO ARQUIVO */
   IF @P_INATIVACONS = 'S' BEGIN

      SELECT @V_NRREG = COUNT(*)
        FROM CONSUMIDOR
       WHERE (CHARINDEX(CDCLIENTE,@P_CDCLIENTE) <> 0)
         AND CDCLIENTE+CDCONSUMIDOR NOT IN (SELECT CDCLIENTETRAB+CDCONSUMIDORTRAB FROM TRABCONSUMIDOR);

      /* ENCONTROU CONSUMIDORES QUE NO VIERAM NO ARQUIVO DE IMPORTAO */
      IF @V_NRREG > 0 BEGIN

         /* NAVEGA NESTES CONSUMIDORES PARA VERIFICA SE DEVE INATIVA-LOS OU NO DE ACORDO COM A FILIAL */
         DECLARE CUR_FILIAL CURSOR FOR
            SELECT  CDCLIENTE,CDCONSUMIDOR
              FROM  CONSUMIDOR
              WHERE (CHARINDEX(CDCLIENTE,@P_CDCLIENTE) <> 0)
                AND CDCLIENTE+CDCONSUMIDOR NOT IN (SELECT CDCLIENTETRAB+CDCONSUMIDORTRAB FROM TRABCONSUMIDOR);

         OPEN CUR_FILIAL;
         FETCH NEXT FROM CUR_FILIAL INTO @V_CDCLIENTE_FIL, @V_CDCONSUMIDOR_FIL;

         WHILE (@@FETCH_STATUS = 0 ) BEGIN

            SELECT  @V_NRREG = COUNT(*)
              FROM  CONSUMIFILIAL
              WHERE CDCLIENTE    = @V_CDCLIENTE_FIL
                AND CDCONSUMIDOR = @V_CDCONSUMIDOR_FIL;

            /* SE O CONSUMIDOR NO ESTIVER ASSOCIADO A NENHUMA FILIAL DEVE SER INATIVADO */
            IF @V_NRREG = 0 BEGIN
               UPDATE CONSUMIDOR
                  SET IDSITCONSUMI = '2'
                WHERE CDCLIENTE    = @V_CDCLIENTE_FIL
                  AND CDCONSUMIDOR = @V_CDCONSUMIDOR_FIL;
            END ELSE BEGIN
               SELECT  @V_NRREG_AUX = COUNT(*)
                 FROM  CONSUMIFILIAL
                 WHERE CDCLIENTE    = @V_CDCLIENTE_FIL
                   AND CDCONSUMIDOR = @V_CDCONSUMIDOR_FIL
                   AND CDFILIAL     = @P_CDFILIAL;

               /* SE O CONSUMIDOR ESTIVER ASSOCIADO A APENAS UMA FILIAL E ESTA  A FILIAL DA IMPORTAO, INATIVA O CONSUMIDOR */
               IF (@V_NRREG = 1) AND (@V_NRREG_AUX = 1) BEGIN
                  UPDATE CONSUMIDOR
                     SET IDSITCONSUMI = '2'
                   WHERE CDCLIENTE    = @V_CDCLIENTE_FIL
                     AND CDCONSUMIDOR = @V_CDCONSUMIDOR_FIL;
               END;
            END;
           FETCH NEXT FROM CUR_FILIAL INTO @V_CDCLIENTE_FIL, @V_CDCONSUMIDOR_FIL;
         END;
         CLOSE CUR_FILIAL;
         DEALLOCATE CUR_FILIAL;
      END;
   END;

   DELETE FROM TRABCONSUMIDOR;
END;

GO
-- VERSAO --
EXEC ATUVEROBJ 'IMPORTA_CONSUMIDOR','0.00.000';
GO