function OperatorService(requestDataSourceEngine, restEngine){
    
    this.getOrganization = function(){
        return requestDataSourceEngine.getDataSource('acl#/findOrganization');
    };
    
    this.saveOperator = function(row){
        return requestDataSourceEngine.setDataSource('acl#/operator', [row]);  
    };
    
    this.saveAccessProfileByOperator = function(rows){
        return requestDataSourceEngine.setDataSource('acl#/accessProfileByOperator', rows);  
    };
    
    this.saveAccessProfileByControlProfile = function(rows){
        return requestDataSourceEngine.setDataSource('acl#/accessProfileByControlProfile', rows);  
    };
    
    this.saveRelatedBranchByOperator = function(rows){
        return requestDataSourceEngine.setDataSource('acl#/relatedBranchByOperator', rows);  
    };
    
    this.saveRelatedOrganizationByOperator = function(rows){
        return requestDataSourceEngine.setDataSource('acl#/relatedOrganizationByOperator', rows);  
    };
    
    this.resetPassword = function(row){
        return requestDataSourceEngine.setDataSource('acl#/resetPassword', [row]);
    };
    
    this.checkIfIsAdm = function(row){
        return restEngine.post('acl#/checkIfIsAdm', {requestType:'Row', row: row});        
    };
    
    this.getOperatorBranches = function(filter){
        return requestDataSourceEngine.getDataSource('acl#/filioperCompleto', filter);        
    };
    
    this.getProfileCanBeEdit =  function(CDOPERADOR){
        var filter = [
                {
                    "name": "CDOPERADORCONT",
                    "value": getLocalVar('CDOPERADOR'),
                    "operator": "="
                },
                {
                    "name": "CDOPERADOR",
                    "value": CDOPERADOR,
                    "operator": "="
                },
                {
                    "name": "NRORG",
                    "value": getLocalVar('NRORG'),
                    "operator": "="
                }
                
                
            ];
        return requestDataSourceEngine.getDataSource('acl#/getProfileCanBeEdit', filter);        
    };

    this.getCdFilialLogged = function(){
        return requestDataSourceEngine.getDataSource('acl#/findCdFilialLogged');
    };
    
    this.createBusinessPartnership = function(row){
        return requestDataSourceEngine.setDataSource('acl#/createBusinessPartnership', [row]).then(function (response){
            return response.dataset.createBusinessPartnership[0];
        });
    };

    this.getParamGeral = function(){
        return requestDataSourceEngine.getDataSource('acl#/paramGeral');
    };

    this.validateNovoCodigo = function(){
        return requestDataSourceEngine.getDataSource('acl#/validateNovoCodigo');
    };

}

Configuration(function(ContextRegister){
    ContextRegister.register('OperatorService', OperatorService);
});